<?php
/**
 * @package	HikaShop for Joomla!
 * @version	2.5.0
 * @author	hikashop.com
 * @copyright	(C) 2010-2015 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgBallisticsProductballistics extends JPlugin{
	function plgBallisticsProductballistics(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onProductballistics($ballistic_sku, $grains, $gun_type, $bullet_type){
		//get a db connection
		$db = JFactory::getDbo();
		//create a new query object
		$query = $db->getQuery(true);
		//select all rows for this ammunition type from ballistics table
		$query
			->select('*')
			->from($db->quoteName('#__ballistics_'))
			->where($db->quoteName('ammunition').' LIKE \''.$ballistic_sku.'\'');
		//reset the query using newly populated query object
		$db->setQuery($query);
		//load the results as a list of stdClass objects
		$ammunition_types = $db->loadObjectList();
		//loop through results
		$barrel = array();
		$shots = array();
		foreach($ammunition_types as $ammunition){
			array_push($barrel,$ammunition->barrel_length);
			array_push($shots,$ammunition->shot_1,$ammunition->shot_2,$ammunition->shot_3,$ammunition->shot_4,$ammunition->shot_5,$ammunition->shot_6,$ammunition->shot_7,$ammunition->shot_8,$ammunition->shot_9,$ammunition->shot_10);
		}
		if(count($barrel) != 0){
    		$barrel = array_sum($barrel)/count($barrel);
		}
		rsort($shots);
		$shots = array_slice($shots,0,10);
		if(count($shots) != 0){
    		$muzzle_velocity = ceil(array_sum($shots)/count($shots));
		}
    	$muzzle_energy = ceil($muzzle_velocity*$muzzle_velocity*$grains/450240);
		if($gun_type == "handgun" && $bullet_type == "match"){
			$power_factor = floor($muzzle_velocity*$grains/1000);
		}elseif($gun_type == "rifle" && $bullet_type == "match"){
			$power_factor = floor($muzzle_velocity*$grains);
		}
		if(count($shots) != 0){
			$html = '
				<div class="ammunition-type">
				  <table class="table">
					<tr>
					  <th width="'.($power_factor != 0 ? "25%" : "33%").'">
						Barrel Length Tested
					  </th>
					  <th width="'.($power_factor != 0 ? "25%" : "33%").'">
						Muzzle Velocity
					  </th>
					  <th width="'.($power_factor != 0 ? "25%" : "33%").'">
						Muzzle Energy
					  </th>
					  '.($power_factor != 0 ?
					  "<th width=\"25%\">
						Power Factor
					  </th>" : "").'
					</tr>
					<tr>
					  <td width="'.($power_factor != 0 ? "25%" : "33%").'">
						'.$barrel.'"
					  </td>
					  <td width="'.($power_factor != 0 ? "25%" : "33%").'">
						'.$muzzle_velocity.' fps
					  </td>
					  <td width="'.($power_factor != 0 ? "25%" : "33%").'">
						'.$muzzle_energy.' ft. lbs.
					  </td>
					  '.($power_factor != 0 ?
					  "<td width=\"25%\">
						'.($gun_type == "handgun" ? $power_factor : $power_factor.' (TSA)').'
					  </td>" : "").'
					</tr>
				  </table>
				</div>';
		}else{
			$html = '';
		}
		return $html;
	}
}